#ifndef __ERASER_H
#define __ERASER_H

#define IGNORE_OP 0
#define LOCKINIT_OP 1
#define IGNOREON_OP 2
#define IGNOREOFF_OP 3
#define REUSE_OP 4
#define DBG_MARK_OP 5
#define GLOBAL_STARTUP_IGNOREOFF_OP 6

#define eraser_lock(x) do {	\
    Bit32u myid = (BX_CPU_THIS_PTR thread_current())&0x3fffffff;	\
    lockset_t lset = add_lock(cur_held(myid),x);	\
    update_lockset(myid,lset);	\
}  while (0);

#define eraser_unlock(x) do {	\
    Bit32u myid = (BX_CPU_THIS_PTR thread_current())&0x3fffffff; \
    lockset_t lset = remove_lock(cur_held(myid),x); \
    update_lockset(myid,lset); \
} while (0);

#define eraser_init(x) do {	\
    Bit32u myid = (BX_CPU_THIS_PTR thread_current())&0x3fffffff; \
    lockset_t mylocks = cur_held(myid); \
    lockset_t lset; \
    if (belongs(mylocks,x)) { \
	lset = remove_lock(mylocks,x); \
	update_lockset(myid,lset); \
    } \
} while (0);

#define INTERRUPT_LOCK 0xffff0001
#define HW_PREFIX_LOCK 0xffff0002

#endif
