#ifndef __LOCKSET_H
#define __LOCKSET_H

#define LOCKSET_EMPTY 0

/* States. */
#define S_VIRGIN        0
#define S_EXCLUSIVE     1
#define S_SHARED        2
#define S_SH_MOD        3

struct lockset 
  {
    unsigned int state : 2;
    unsigned int seq : 10;
    unsigned int value : 20;
  };

typedef unsigned int address_t;
typedef unsigned long locksetidx_t;
typedef locksetidx_t lockset_t;

locksetidx_t add_lock(locksetidx_t index, address_t newlock);
locksetidx_t remove_lock(locksetidx_t index, address_t newlock);
locksetidx_t intersect_locksets(locksetidx_t index1, locksetidx_t index2);
bool belongs(locksetidx_t index, address_t lock);
void lockset_dump(locksetidx_t, Bit32u locks[], int cnt);

locksetidx_t cur_held(unsigned threadId);
void update_lockset(unsigned threadId, locksetidx_t lockset);

void set_ignore(unsigned threadId, bool val);
bool ignore_on(unsigned threadId);

#endif
