
#include "bochs.h"
#define LOG_THIS BX_MEM_THIS


  void BX_CPP_AttrRegparmN(3)
BX_MEM_C::readPhysicalTaintPage(BX_CPU_C *cpu, Bit32u addr, unsigned len, void *data)
{
  Bit32u *data_ptr;
  Bit32u a20addr;

  a20addr = A20ADDR(addr);
  assert(len==1);
  *(Bit32u *)data = 0x0;	//initialize, so that if we are unable to read mem, we return 0

  if ( (a20addr + len) <= BX_MEM_THIS len ) {
    // all of data is within limits of physical memory
    if ( (a20addr & 0xfff80000) != 0x00080000 ) {
      if (len == 4) {
#ifdef __i386__
        *(Bit32u *)data = taint_vector[a20addr];
        *((Bit32u *)data+1) = taint_vector[a20addr+1];
        *((Bit32u *)data+2) = taint_vector[a20addr+2];
        *((Bit32u *)data+3) = taint_vector[a20addr+3];
#else
	printf("Not yet supported for big endian host platforms.\n");
	assert(0);
#endif
        return;
        }
      if (len == 2) {
#ifdef __i386__
        *(Bit32u *)data = taint_vector[a20addr];
        *((Bit32u *)data+1) = taint_vector[a20addr+1];
#else
	printf("Not yet supported for big endian host platforms.\n");
	assert(0);
#endif
	/*
	if (*(Bit16u *)data && g_instruction_display_count>0) {
		printf("%s %d: tainted dword read from addr %x. data=%x.\n",__func__,__LINE__,addr,*(Bit16u*)data);
		g_instruction_display_count = 512;
	}
	*/
        return;
        }
      if (len == 1) {
#ifdef __i386__
        *(Bit32u *)data = taint_vector[a20addr];
#else
	printf("Not yet supported for big endian host platforms.\n");
	assert(0);
#endif
        return;
        }
      // len == 3 case can just fall thru to special cases handling
      }


#ifdef BX_LITTLE_ENDIAN
    data_ptr = (Bit32u *) data;
#else // BX_BIG_ENDIAN
    data_ptr = (Bit32u *) data + (len - 1);
#endif



read_one:
    if ( (a20addr & 0xfff80000) != 0x00080000 ) {
      // addr *not* in range 00080000 .. 000FFFFF
      *data_ptr = taint_vector[a20addr];
inc_one:
      if (len == 1) return;
      len--;
      a20addr++;
#ifdef BX_LITTLE_ENDIAN
      data_ptr++;
#else // BX_BIG_ENDIAN
      data_ptr--;
#endif
      goto read_one;
      }

    // addr in range 00080000 .. 000FFFFF
#if BX_PCI_SUPPORT == 0
    if ((a20addr <= 0x0009ffff) || (a20addr >= 0x000c0000) ) {
      // regular memory 80000 .. 9FFFF, C0000 .. F0000
      *data_ptr = taint_vector[a20addr];
      goto inc_one;
      }
    return; //assert(0);
    // VGA memory A0000 .. BFFFF
    //*data_ptr = DEV_vga_mem_read(a20addr);
    //BX_DBG_UCMEM_REPORT(a20addr, 1, BX_READ, *data_ptr); // obsolete
    //goto inc_one;
#else   // #if BX_PCI_SUPPORT == 0
    if (a20addr <= 0x0009ffff) {
      *data_ptr = taint_vector[a20addr];
      goto inc_one;
      }
    if (a20addr <= 0x000BFFFF) {
      assert(0);
      // VGA memory A0000 .. BFFFF
      //*data_ptr = DEV_vga_mem_read(a20addr);
      //BX_DBG_UCMEM_REPORT(a20addr, 1, BX_READ, *data_ptr);
      //goto inc_one;
      }

    // a20addr in C0000 .. FFFFF
    if (!bx_options.Oi440FXSupport->get ()) {
      *data_ptr = taint_vector[a20addr];
      goto inc_one;
    }
    else assert(0);
    goto inc_one;
#endif  // #if BX_PCI_SUPPORT == 0
    }
  else {
    // some or all of data is outside limits of physical memory
    unsigned i;

#ifdef BX_LITTLE_ENDIAN
    data_ptr = (Bit32u *) data;
#else // BX_BIG_ENDIAN
    data_ptr = (Bit32u *) data + (len - 1);
#endif

#if BX_SUPPORT_VBE
    // Check VBE LFB support
    if ((a20addr >= VBE_DISPI_LFB_PHYSICAL_ADDRESS) &&
        (a20addr <  (VBE_DISPI_LFB_PHYSICAL_ADDRESS +  VBE_DISPI_TOTAL_VIDEO_MEMORY_BYTES)))
    {
      assert(0);
      return;
    }
#endif

#if BX_SUPPORT_APIC
    //assert(0);
    return;
#endif
    for (i = 0; i < len; i++) {
#if BX_PCI_SUPPORT == 0
      if (a20addr < BX_MEM_THIS len)
        *data_ptr = taint_vector[a20addr];
      else
        *data_ptr = 0xffffffff;
#else   // BX_PCI_SUPPORT == 0
      if (a20addr < BX_MEM_THIS len) {
        if ((a20addr >= 0x000C0000) && (a20addr <= 0x000FFFFF)) {
          if (!bx_options.Oi440FXSupport->get ())
            *data_ptr = taint_vector[a20addr];
          else {
            switch (DEV_pci_rd_memtype(a20addr & 0xFC000)) {
              case 0x0:   // Read from ROM
                *data_ptr = taint_vector[a20addr];
                //BX_INFO(("Reading from ROM %08x, Data %02x ", (unsigned) a20addr, *data_ptr));
                break;

              case 0x1:   // Read from Shadow RAM
		assert(0);
                break;
              default:
                BX_PANIC(("readPhysicalPage: default case"));
              } // Switch
            }
          }
        else {
          *data_ptr = taint_vector[a20addr];
          BX_INFO(("Reading from Norm %08x, Data %02x  ", (unsigned) a20addr, *data_ptr));
          }
        }
      else 
        *data_ptr = 0xffffffff;
#endif  // BX_PCI_SUPPORT == 0
      addr++;
      a20addr = (addr);
#ifdef BX_LITTLE_ENDIAN
      data_ptr++;
#else // BX_BIG_ENDIAN
      data_ptr--;
#endif
      }
    return;
    }
}

  void BX_CPP_AttrRegparmN(3)
BX_MEM_C::writePhysicalTaintPage(BX_CPU_C *cpu, Bit32u addr, unsigned len, void *data)
{
  Bit32u *data_ptr;
  Bit32u a20addr;

  assert(len==1);

  a20addr = A20ADDR(addr);

  // Note: accesses should always be contained within a single page now.

  //if (*(Bit8u *)data!=0xff && *(Bit8u *)data!=0) assert(0);
  //if (*(Bit8u *)data==0xff) assert(0);

  if ( a20addr <= BX_MEM_THIS len ) {

    //LOG_MEM_TAINT(cpu,addr,len,&taint_vector[a20addr],data,true);

    // all of data is within limits of physical memory
    if ( (a20addr & 0xfff80000) != 0x00080000 ) {
      if (len == 4) {
#ifdef __i386__
        taint_vector[a20addr]  = *(Bit32u*)data;
        taint_vector[a20addr+1]  = *((Bit32u*)data+1);
        taint_vector[a20addr+2]  = *((Bit32u*)data+2);
        taint_vector[a20addr+3]  = *((Bit32u*)data+3);
#else
	printf("Not yet supported for big endian host platforms.\n");
	assert(0);
#endif
        return;
        }
      if (len == 2) {
#ifdef __i386__
        taint_vector[a20addr]  = *(Bit32u*)data;
        taint_vector[a20addr+1]  = *((Bit32u*)data+1);
#else
	printf("Not yet supported for big endian host platforms.\n");
	assert(0);
#endif
        return;
        }
      if (len == 1) {
#ifdef __i386__
        taint_vector[a20addr]  = *(Bit32u*)data;
#else
	printf("Not yet supported for big endian host platforms.\n");
	assert(0);
#endif
        return;
        }
      // len == other, just fall thru to special cases handling
      }

#ifdef BX_LITTLE_ENDIAN
  data_ptr = (Bit32u *) data;
#else // BX_BIG_ENDIAN
  data_ptr = (Bit32u *) data + (len - 1);
#endif

write_one:
    if ( (a20addr & 0xfff80000) != 0x00080000 ) {
      // addr *not* in range 00080000 .. 000FFFFF
      taint_vector[a20addr] = *data_ptr;
inc_one:
      if (len == 1) return;
      len--;
      a20addr++;
#ifdef BX_LITTLE_ENDIAN
      data_ptr++;
#else // BX_BIG_ENDIAN
      data_ptr--;
#endif
      goto write_one;
      }

    // addr in range 00080000 .. 000FFFFF

    if (a20addr <= 0x0009ffff) {
      // regular memory 80000 .. 9FFFF
      taint_vector[a20addr] = *data_ptr;
      goto inc_one;
      }
    if (a20addr <= 0x000bffff) {
      // VGA memory A0000 .. BFFFF
      return; //assert(0);
      //DEV_vga_mem_write(a20addr, *data_ptr);
      //BX_DBG_DIRTY_PAGE(a20addr >> 12);
      //BX_DBG_UCMEM_REPORT(a20addr, 1, BX_WRITE, *data_ptr); // obsolete
      goto inc_one;
      }
    // adapter ROM     C0000 .. DFFFF
    // ROM BIOS memory E0000 .. FFFFF
    // (ignore write)
    //BX_INFO(("ROM lock %08x: len=%u",
    //  (unsigned) a20addr, (unsigned) len));
#if BX_PCI_SUPPORT == 0
#if BX_SHADOW_RAM
    // Write it since its in shadow RAM
    taint_vector[a20addr] = *data_ptr;
#else
    // ignore write to ROM
#endif
#else
    // Write Based on 440fx Programming
    if (bx_options.Oi440FXSupport->get () &&
        ((a20addr >= 0xC0000) && (a20addr <= 0xFFFFF))) {
      switch (DEV_pci_wr_memtype(a20addr & 0xFC000)) {
        case 0x1:   // Writes to ShadowRAM
	  assert(0);
//        BX_INFO(("Writing to ShadowRAM %08x, len %u ! ", (unsigned) a20addr, (unsigned) len));
          shadow[a20addr - 0xc0000] = *data_ptr;
          BX_DBG_DIRTY_PAGE(a20addr >> 12);
          goto inc_one;

        case 0x0:   // Writes to ROM, Inhibit
	  assert(0);
          //BX_DEBUG(("Write to ROM ignored: address %08x, data %02x", (unsigned) a20addr, *data_ptr));
          goto inc_one;
        default:
          BX_PANIC(("writePhysicalPage: default case"));
          goto inc_one;
        }
      }
#endif
    goto inc_one;
    }

  else {
    // some or all of data is outside limits of physical memory
    unsigned i;

#ifdef BX_LITTLE_ENDIAN
  data_ptr = (Bit32u *) data;
#else // BX_BIG_ENDIAN
  data_ptr = (Bit32u *) data + (len - 1);
#endif


#if BX_SUPPORT_VBE
    // Check VBE LFB support
    
    if ((a20addr >= VBE_DISPI_LFB_PHYSICAL_ADDRESS) &&
        (a20addr <  (VBE_DISPI_LFB_PHYSICAL_ADDRESS +  VBE_DISPI_TOTAL_VIDEO_MEMORY_BYTES)))
    {
      assert(0);
      return;
    }
    
#endif    
 

#if BX_SUPPORT_APIC
    //assert(0);
    return;
#endif
    for (i = 0; i < len; i++) {
      if (a20addr < BX_MEM_THIS len) {
        taint_vector[a20addr] = *data_ptr;
        }
      // otherwise ignore byte, since it overruns memory
      addr++;
      a20addr = (addr);
#ifdef BX_LITTLE_ENDIAN
      data_ptr++;
#else // BX_BIG_ENDIAN
      data_ptr--;
#endif
      }
    return;
    }
}
