#ifndef __MYDEBUG_H
#define __MYDEBUG_H

#define ACCESS_LINEAR 0
#define L1 0
#define LOCKS 0
#define CHECKBOCHS 1
#define WRN 1
#define ERR 1

void checkbochs_log (const char *fmt, ...) ;

#define DBG(l,x) if (l) {						\
	checkbochs_log x;							\
	/*bx_dbg_disassemble_current(-1,0);*/				\
}

#define PANIC(...) do {				\
	printf("PANIC at %s:%d in %s(): ",__FILE__,__LINE__,__func__);   \
	BX_CPU(0)->panic(__VA_ARGS__);		\
} while(0)

#define ASSERT(CONDITION)					\
	if (CONDITION) { } else {				\
		PANIC ("assertion `%s' failed.", #CONDITION);	\
	}

#endif
