#define NEED_CPU_REG_SHORTCUTS 1
#include "bochs.h"
#define LOG_THIS BX_CPU_THIS_PTR

#include "taint/globals.h"
#include "taint/mydebug.h"
#include "taint/lockset.h"

#if BX_USE_CPU_SMF
#define this (BX_CPU(0))
#endif


#if BX_SUPPORT_PAGING

#define InstrTLB_Stats()
#define InstrTLB_Increment(v)

// ==============================================================


// Translate a linear address to a physical address, for
// a data access (D)

  Bit32s BX_CPP_AttrRegparmN(3)
BX_CPU_C::taint_dtranslate_linear(bx_address laddr, unsigned pl, unsigned rw)
{
  bx_address   lpf;
  Bit32u   ppf, poffset, TLB_index, error_code, paddress;
  Bit32u   pde, pde_addr;
  bx_bool  isWrite;
  Bit32u   accessBits, combined_access;
  unsigned priv_index;

  // CR4.PAE==0 (and MSR.LMA==0)

  lpf       = laddr & 0xfffff000; // linear page frame
  poffset   = laddr & 0x00000fff; // physical offset
  TLB_index = BX_TLB_INDEX_OF(lpf);


  //isWrite = (rw>=BX_WRITE); // write or r-m-w
  isWrite = 0; // sorav: allow write accesses even if you have only read permissions on the address

  if (BX_CPU_THIS_PTR TLB.entry[TLB_index].lpf == BX_TLB_LPF_VALUE(lpf)) {
    paddress   = BX_CPU_THIS_PTR TLB.entry[TLB_index].ppf | poffset;
    accessBits = BX_CPU_THIS_PTR TLB.entry[TLB_index].accessBits;
    if (accessBits & (1 << ((isWrite<<1) | pl)) ) {
      return(paddress);
      }

    // The current access does not have permission according to the info
    // in our TLB cache entry.  Re-walk the page tables, in case there is
    // updated information in the memory image, and let the long path code
    // generate an exception if one is warranted.
    }

  return(-1); //return -1 for failure
}


// Translate a linear address to a physical address, for
// an instruction fetch access (I)

  Bit32u BX_CPP_AttrRegparmN(2)
BX_CPU_C::taint_itranslate_linear(bx_address laddr, unsigned pl)
{
  //assign_type(type8,generic_type_executed_code8);

  ////Bit32u pAddr = dtranslate_linear_type(laddr, pl, BX_READ);
  //printf("Assigning a codebyte.\n");
  //access_linear_type(laddr,1,pl,BX_WRITE,type8);
  //typestats_t stats;
  //stats.print(BX_CPU_THIS_PTR mem->type_vector,BX_CPU_THIS_PTR mem->len);
  exit(0);
}


lockset *
BX_CPU_C::access_linear_taint(bx_address laddr)
{
    if (!BX_CPU_THIS_PTR cr0.pg)
        return NULL;

    BX_MEM_C *m = BX_CPU_THIS_PTR mem;
    Bit32u paddr = laddr - PHYS_BASE;
    return paddr < m->len ? (lockset *) &m->taint_vector[paddr] : NULL;
}

#endif
