#define NEED_CPU_REG_SHORTCUTS 1
#include "bochs.h"
#define LOG_THIS BX_CPU_THIS_PTR

#if BX_USE_CPU_SMF
#define this (BX_CPU(0))
#endif


#if BX_SUPPORT_PAGING

#define InstrTLB_Stats()
#define InstrTLB_Increment(v)

// ==============================================================


  int BX_CPP_AttrRegparmN(3)
BX_CPU_C::access_linear_silent(bx_address laddr, unsigned length, unsigned pl,
    unsigned rw, void *data)
{
  Bit32u pageOffset;
  unsigned xlate_rw;

  assert(rw==BX_READ);
  if (rw==BX_RW) {
    xlate_rw = BX_RW;
    rw = BX_READ;
  }
  else {
    xlate_rw = rw;
  }

  pageOffset = laddr & 0x00000fff;

  if (BX_CPU_THIS_PTR cr0.pg) {
    /* check for reference across multiple pages */
    if ( (pageOffset + length) <= 4096 ) {
      // Access within single page.
      BX_CPU_THIS_PTR address_xlation.taint_paddress1 =
          taint_dtranslate_linear(laddr, pl, xlate_rw);
      BX_CPU_THIS_PTR address_xlation.taint_pages     = 1;

      if (rw == BX_READ) {
        BX_INSTR_LIN_READ(BX_CPU_ID, laddr, BX_CPU_THIS_PTR address_xlation.taint_paddress1, length);
        BX_CPU_THIS_PTR mem->readPhysicalPage(this,
            BX_CPU_THIS_PTR address_xlation.taint_paddress1, length, data );
        }
      else {
        BX_INSTR_LIN_WRITE(BX_CPU_ID, laddr, BX_CPU_THIS_PTR address_xlation.taint_paddress1, length);
        BX_CPU_THIS_PTR mem->writePhysicalPage(this,
            BX_CPU_THIS_PTR address_xlation.taint_paddress1, length, data);
        }
      //if (rw==BX_WRITE) BX_CPU_THIS_PTR address_xlation.taint_write_paddress1 = BX_CPU_THIS_PTR address_xlation.taint_paddress1;
      }
    else {
      // access across 2 pages
      BX_CPU_THIS_PTR address_xlation.taint_paddress1 =
          taint_dtranslate_linear(laddr, pl, xlate_rw);
      BX_CPU_THIS_PTR address_xlation.taint_len1 = 4096 - pageOffset;
      BX_CPU_THIS_PTR address_xlation.taint_len2 = length -
          BX_CPU_THIS_PTR address_xlation.taint_len1;
      BX_CPU_THIS_PTR address_xlation.taint_pages     = 2;
      BX_CPU_THIS_PTR address_xlation.taint_paddress2 =
          taint_dtranslate_linear(laddr + BX_CPU_THIS_PTR address_xlation.taint_len1,
                            pl, xlate_rw);

#ifdef BX_LITTLE_ENDIAN
      if (rw == BX_READ) {
        BX_CPU_THIS_PTR mem->readPhysicalPage(this, BX_CPU_THIS_PTR address_xlation.taint_paddress1,
                             BX_CPU_THIS_PTR address_xlation.taint_len1, data);
        BX_CPU_THIS_PTR mem->readPhysicalPage(this, BX_CPU_THIS_PTR address_xlation.taint_paddress2,
                             BX_CPU_THIS_PTR address_xlation.taint_len2,
                             ((Bit32u*)data) + BX_CPU_THIS_PTR address_xlation.taint_len1);
        }
      else {
        BX_CPU_THIS_PTR mem->writePhysicalPage(this, BX_CPU_THIS_PTR address_xlation.taint_paddress1,
                              BX_CPU_THIS_PTR address_xlation.taint_len1, data);
        BX_CPU_THIS_PTR mem->writePhysicalPage(this, BX_CPU_THIS_PTR address_xlation.taint_paddress2,
                              BX_CPU_THIS_PTR address_xlation.taint_len2,
                              ((Bit32u*)data) + BX_CPU_THIS_PTR address_xlation.taint_len1);
        }

#else // BX_BIG_ENDIAN
      if (rw == BX_READ) {
        BX_CPU_THIS_PTR mem->readPhysicalPage(this, BX_CPU_THIS_PTR address_xlation.taint_paddress1,
                             BX_CPU_THIS_PTR address_xlation.taint_len1,
                             ((Bit32u*)data) + (length - BX_CPU_THIS_PTR address_xlation.taint_len1));
        BX_CPU_THIS_PTR mem->readPhysicalPage(this, BX_CPU_THIS_PTR address_xlation.taint_paddress2,
                             BX_CPU_THIS_PTR address_xlation.taint_len2, data);
        }
      else {
        BX_CPU_THIS_PTR mem->writePhysicalPage(this, BX_CPU_THIS_PTR address_xlation.taint_paddress1,
                              BX_CPU_THIS_PTR address_xlation.taint_len1,
                              ((Bit32u*)data) + (length - BX_CPU_THIS_PTR address_xlation.taint_len1));
        BX_CPU_THIS_PTR mem->writePhysicalPage(this, BX_CPU_THIS_PTR address_xlation.taint_paddress2,
                              BX_CPU_THIS_PTR address_xlation.taint_len2, data);
        }
#endif

      //if (rw==BX_WRITE) BX_CPU_THIS_PTR address_xlation.taint_write_paddress1 = BX_CPU_THIS_PTR address_xlation.taint_paddress1;
      }
    }

  else {
    // Paging off.
    if ( (pageOffset + length) <= 4096 ) {
      // Access within single page.
      BX_CPU_THIS_PTR address_xlation.taint_paddress1 = laddr;
      BX_CPU_THIS_PTR address_xlation.taint_pages     = 1;
      if (rw == BX_READ) {

        // Let access fall through to the following for this iteration.
        BX_CPU_THIS_PTR mem->readPhysicalPage(this, laddr, length, data);
        }
      else { // Write
        BX_CPU_THIS_PTR mem->writePhysicalPage(this, laddr, length, data);
        }
      }
    else {
      // Access spans two pages.
      BX_CPU_THIS_PTR address_xlation.taint_paddress1 = laddr;
      BX_CPU_THIS_PTR address_xlation.taint_len1 = 4096 - pageOffset;
      BX_CPU_THIS_PTR address_xlation.taint_len2 = length -
          BX_CPU_THIS_PTR address_xlation.taint_len1;
      BX_CPU_THIS_PTR address_xlation.taint_pages     = 2;
      BX_CPU_THIS_PTR address_xlation.taint_paddress2 = laddr +
          BX_CPU_THIS_PTR address_xlation.taint_len1;

#ifdef BX_LITTLE_ENDIAN
      if (rw == BX_READ) {
        BX_CPU_THIS_PTR mem->readPhysicalPage(this,
            BX_CPU_THIS_PTR address_xlation.taint_paddress1,
            BX_CPU_THIS_PTR address_xlation.taint_len1, data);
        BX_CPU_THIS_PTR mem->readPhysicalPage(this,
            BX_CPU_THIS_PTR address_xlation.taint_paddress2,
            BX_CPU_THIS_PTR address_xlation.taint_len2,
            ((Bit32u*)data) + BX_CPU_THIS_PTR address_xlation.taint_len1);
        }
      else {
        BX_CPU_THIS_PTR mem->writePhysicalPage(this,
            BX_CPU_THIS_PTR address_xlation.taint_paddress1,
            BX_CPU_THIS_PTR address_xlation.taint_len1, data);
        BX_CPU_THIS_PTR mem->writePhysicalPage(this,
            BX_CPU_THIS_PTR address_xlation.taint_paddress2,
            BX_CPU_THIS_PTR address_xlation.taint_len2,
            ((Bit32u*)data) + BX_CPU_THIS_PTR address_xlation.taint_len1);
        }

#else // BX_BIG_ENDIAN
      if (rw == BX_READ) {
        BX_CPU_THIS_PTR mem->readPhysicalPage(this,
            BX_CPU_THIS_PTR address_xlation.taint_paddress1,
            BX_CPU_THIS_PTR address_xlation.taint_len1,
            ((Bit32u*)data) + (length - BX_CPU_THIS_PTR address_xlation.taint_len1));
        BX_CPU_THIS_PTR mem->readPhysicalPage(this,
            BX_CPU_THIS_PTR address_xlation.taint_paddress2,
            BX_CPU_THIS_PTR address_xlation.taint_len2, data);
        }
      else {
        BX_CPU_THIS_PTR mem->writePhysicalPage(this,
            BX_CPU_THIS_PTR address_xlation.taint_paddress1,
            BX_CPU_THIS_PTR address_xlation.taint_len1,
            ((Bit32u*)data) + (length - BX_CPU_THIS_PTR address_xlation.taint_len1));
        BX_CPU_THIS_PTR mem->writePhysicalPage(this,
            BX_CPU_THIS_PTR address_xlation.taint_paddress2,
            BX_CPU_THIS_PTR address_xlation.taint_len2, data);
        }
#endif
      }
    //if (rw==BX_WRITE) BX_CPU_THIS_PTR address_xlation.taint_write_paddress1 = BX_CPU_THIS_PTR address_xlation.taint_paddress1;
    }
}

#endif
